
#line 607 "nuweb.w"
#include "global.h"

#line 993 "nuweb.w"
void pass1(char *file_name)
{
  if (verbose_flag)
    fprintf(stderr, "reading %s\n", file_name);
  source_open(file_name);
  init_scraps();
  macro_names = NULL;
  file_names = NULL;
  user_names = NULL;
  
#line 1014 "nuweb.w"
  {
    int c = source_get();
    while (c != EOF) {
      if (c == '@')
        
#line 1029 "nuweb.w"
        {
          c = source_get();
          switch (c) {
            case 'O':
            case 'o': 
#line 1055 "nuweb.w"
                      {
                        Name *name = collect_file_name(); /* returns a pointer to the name entry */
                        int scrap = collect_scrap();      /* returns an index to the scrap */
                        
#line 1077 "nuweb.w"
                        {
                          Scrap_Node *def = (Scrap_Node *) arena_getmem(sizeof(Scrap_Node));
                          def->scrap = scrap;
                          def->next = name->defs;
                          name->defs = def;
                        }
                        
#line 1058 "nuweb.w"
                      
                      }
                      
#line 1033 "nuweb.w"
        
                      break;
            case 'D':
            case 'd': 
#line 1064 "nuweb.w"
                      {
                        Name *name = collect_macro_name();
                        int scrap = collect_scrap();
                        
#line 1077 "nuweb.w"
                        {
                          Scrap_Node *def = (Scrap_Node *) arena_getmem(sizeof(Scrap_Node));
                          def->scrap = scrap;
                          def->next = name->defs;
                          name->defs = def;
                        }
                        
#line 1067 "nuweb.w"
                      
                      }
                      
#line 1036 "nuweb.w"
        
                      break;
          }
        }
        
#line 1018 "nuweb.w"
  
      c = source_get();
    }
  }
  
#line 1002 "nuweb.w"

  if (tex_flag)
    search();
  
#line 1095 "nuweb.w"
  {
    reverse_lists(file_names);
    reverse_lists(macro_names);
    reverse_lists(user_names);
  }
  
#line 1005 "nuweb.w"

}
